import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to remove an object class from the schema.
  *
  * usage: java DeleteObjectClass
  */
class DeleteObjectClass {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	// Must authenticate as directory administrator in order to update schema
	env.put(Context.SECURITY_PRINCIPAL, "cn=Directory Manager");
	env.put(Context.SECURITY_CREDENTIALS, "secret99");

	// These are required for using with Netscape Directory Server 3.x
	env.put(Context.SECURITY_AUTHENTICATION, "simple");
	env.put("com.sun.naming.netscape.schemaBugs", "true");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get the schema tree root
	    DirContext schema = ctx.getSchema("");

	    // Remove the schema object for "fooObjectClass"
    	    schema.destroySubcontext("ClassDefinition/fooObjectClass");
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
