import javax.naming.*;
import javax.naming.directory.*;
import java.util.Hashtable;

/**
  * Demonstrates how to get an attribute syntax's schema from an
  * attribute that uses that syntax.
  *
  * usage: java GetSyntax
  */
class GetSyntax {
    public static void main(String[] args) {

	// Set up environment for creating initial context
	Hashtable env = new Hashtable(11);
	env.put(Context.INITIAL_CONTEXT_FACTORY, 
	    "com.sun.jndi.ldap.LdapCtxFactory");
	env.put(Context.PROVIDER_URL, "ldap://localhost:389/o=JNDITutorial");

	try {
	    // Create the initial context
	    DirContext ctx = new InitialDirContext(env);

	    // Get an attribute that uses that syntax
	    Attributes attrs = ctx.getAttributes("cn=Ted Geisel, ou=People",
		new String[]{"cn"});
	    Attribute cnAttr = attrs.get("cn");

	    // Get its attribute syntax definition
	    DirContext dsSyntax = cnAttr.getAttributeSyntaxDefinition();

	    // Get cnSyntax's attributes
	    Attributes synAttrs = dsSyntax.getAttributes("");

	    System.out.println(synAttrs);
	} catch (NamingException e) {
	    e.printStackTrace();
	}
    }
}
